# List the latest versions of configurations.

> Templates API · Templating

```http
GET https://app.mk.io/api/v1/projects/{project_name}/templating/configs
```

## Listing, Sorting and Filtering Configurations

This endpoint returns the list of configurations in the specified project.

### Sorting

The results from this endpoint can be ordered using the `$orderby` query parameter. Specify a list of field names, separated by commas
where each one can optionally specify `asc` or `desc`.

Sorting is valid on the following fields: `created`, `hash`, `id`, `labels`, `name`, `type`, `updated`, `updatedBy`

### Filtering

There are two ways to filter the set of returned configurations from this endpoint - the first is to use the `$filter` query parameter, the second is to use the
`$label_key` and `$label` query parameters.

The `$filter` query parameter allows for configurations to be filtered on the basis of fields in the schema using OData query syntax.
See [this document](https://learn.microsoft.com/en-us/odata/concepts/queryoptions-overview#filter) for more details on the syntax used.

Filters are valid on the following fields: `created`, `createdBy`, `createdByEmail`, `createdByName`, `hash`, `id`, `labels`, `name`, `type`, `updated`, `updatedBy`, `updatedByEmail`, `updatedByName`

`$label_key` and `$label` are specific to querying configurations based on their labels. Labels are a set of key-value pairs that can be used to identify configurations with
any arbitrary metadata you want, specifically for the purpose of retrieving relevant subsets of configurations.

### Examples:

`?$top=10` - Returns only the first 10 configurations from the list.

`?$orderby=name desc` - Sorts configurations by name in descending order.

`?$filter=name eq 'descriptive name'` - Returns configurations that match the provided name.

`?$orderby=created desc` - Sorts configurations by creation date in descending order.

`?$filter=created ge 2021-01-01T00:00:00Z` - Returns configurations created after January 1, 2021.

`?$label=studio=paravalley` - Returns configurations with the label `studio` set to `paravalley`.

`?$label=release-date~2023` - Returns configurations with the label `release-date` set to a value that contains `2023`.

`?$label_key=studio&label_key=release-date` - Returns configurations with any value set for the `studio` label and the `release-date` label.

RBAC Capability Required: `templating.configs.get`

## Authentication

- `Authorization` header — Bearer authentication of the form `Bearer <token>`.

## Path parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `project_name` | string | Yes | — |

## Query parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `$orderby` | string | No | Specifies the key by which the result collection should be ordered. |
| `$filter` | string | No | Restricts the set of items returned. |
| `$top` | string | No | Specifies a non-negative integer `n` that limits the number of items returned from a collection. The service returns the number of available items up to but not greater than the specified value `n`. |
| `$skiptoken` | string | No | Specifies a start offset to support paginated results. Use `@odata.nextLink` in the result object to enumerate the collection - it will be present only if there's more than one page of entities. |
| `$label_key` | string | No | Filters the set to the specified label key. If multiple $label_keys are specified, matching items must have all labels. |
| `$label` | string | No | Filters the set to the specified label key/value pair. Supports equality, inequality, and inexact matching. If multiple values are provided for the same key, items matching either value will be returned. |

## Example request

```bash
curl -X GET "https://app.mk.io/api/v1/projects/{project_name}/templating/configs" \
  -H "Authorization: Bearer <token>"
```

## Responses

### 200 — A list of configurations

- `@odata.nextLink` · string · Optional — @odata.nextLink URL if the page length and number of items match.
- `supplemental` · object · **Required** — Supplemental info
  - `count` · integer · **Required** — Number of items returned
  - `kind` · string · **Required** — Type of items in the list
  - `operation` · string · **Required** — Operation type. Should always say 'list'
  - `pagination` · object · **Required** — Pagination info
    - `end` · integer · **Required** — Position of the last item in the list
    - `records` · integer · **Required** — Total number of items returned in the list
    - `start` · integer · **Required** — Position of the first item in the list
    - `total` · integer · **Required** — Total number of items in the project
  - `subscription` · object · Optional — Project info
    - `id` · string · **Required** — Project ID
    - `name` · string · **Required** — Project name
- `value` · list of objects · **Required** — A list of objects
  - Array items (object):
    - `kind` · string · Optional — The kind of record.
    - `metadata` · object · **Required** — Metadata.
      - `created` · string · Optional · _format: date-time_ — The time when the resource was created
      - `createdBy` · string · Optional · _format: uuid_ — ID of the user who created the resource
      - `createdByEmail` · string · Optional — Email of the user who created the resource
      - `description` · string · Optional · _0-200 characters_ · _Defaults to _ — Optional description of revision of the configuration.
      - `hash` · string · Optional — Hash of this configuration.
      - `id` · string · **Required** · _format: uuid_ — The ID of the resource
      - `labels` · map from strings to string · Optional — A dictionary of labels associated with the resource
        - `[any key]` · string — map of additional properties
      - `name` · string · Optional — The name of the resource
      - `tags` · list of strings · Optional — Tags for this revision of the config.
        - Array items (string):
      - `type` · string · **Required** — Type of configuration.
      - `updated` · string · Optional · _format: date-time_ — The time when the resource was last updated
      - `updatedBy` · string · Optional · _format: uuid_ — ID of the user who last updated the resource
      - `updatedByEmail` · string · Optional — Email of the user who last updated the resource
    - `spec` · object · Optional — Specification.
      - `config` · map from strings to any · Optional — The contents of the config.
        - `[any key]` · any — map of additional properties
      - `parameters` · list of objects · Optional — Parameters exposed by this configuration.
        - Array items (object):
          - `description` · string or null · Optional — Optional description of the parameter.
          - `name` · string · **Required** — The name of the parameter.
          - `paths` · list of strings · **Required** · _1+ items_ — List of paths in the config where this parameter applies. Each path must be unique.
            - Array items (string):
    - `status` · object · Optional — Computed status including available input/output pin names.
      - `inputPins` · list of objects · Optional — Available input pin names for this template.
        - Array items (object):
          - `allowMultipleBindings` · boolean · Optional — Whether multiple flow inputs/outputs can reference this pin.
          - `name` · string · **Required** — The pin name to use for transformInput or transformOutput.
      - `outputPins` · list of objects · Optional — Available output pin names for this template.
        - Array items (object):
          - `allowMultipleBindings` · boolean · Optional — Whether multiple flow inputs/outputs can reference this pin.
          - `name` · string · **Required** — The pin name to use for transformInput or transformOutput.

Example:

```json
{
  "@odata.nextLink": "string",
  "supplemental": {
    "count": 0,
    "kind": "string",
    "operation": "string",
    "pagination": {
      "end": 0,
      "records": 0,
      "start": 0,
      "total": 0
    },
    "subscription": {
      "id": "string",
      "name": "string"
    }
  },
  "value": [
    {
      "kind": "string",
      "metadata": {
        "created": "2024-01-01T00:00:00Z",
        "createdBy": "00000000-0000-0000-0000-000000000000",
        "createdByEmail": "string",
        "description": "",
        "hash": "string",
        "id": "00000000-0000-0000-0000-000000000000",
        "labels": {
          "label1": "value1",
          "label2": "value2"
        },
        "name": "string",
        "tags": [
          "string"
        ],
        "type": "string",
        "updated": "2024-01-01T00:00:00Z",
        "updatedBy": "00000000-0000-0000-0000-000000000000",
        "updatedByEmail": "string"
      },
      "spec": {
        "config": {
          "key": null
        },
        "parameters": [
          {
            "description": "string",
            "name": "source_id_0",
            "paths": "[\"/input/sources/0/id\"]"
          }
        ]
      },
      "status": {
        "inputPins": [
          {
            "allowMultipleBindings": true,
            "name": "string"
          }
        ],
        "outputPins": [
          {
            "allowMultipleBindings": true,
            "name": "string"
          }
        ]
      }
    }
  ]
}
```

### 400 — Bad Request

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 401 — Unauthorized

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 403 — Forbidden

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 404 — Not Found

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 429 — Too Many Requests

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 500 — Internal Server Error

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

---

Source spec: `templates-api` · operationId: `[get]_/api/v1/projects/{project_name}/templating/configs`
